image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/node:20

include:
  - project: 'secata-public/pom/shared-ci'
    file: 'root.yml'
    ref: 'v.2.82.0'
  - project: 'secata-public/pom/shared-ci'
    file: 'generic-checks.yml'
    ref: 'v.2.82.0'

cache:
  key: global-npm-cache
  paths:
    - node_modules

lint:
  stage: test
  script:
    - yarn install --immutable
    - yarn lint
  rules: !reference [.rules, on-mr]

snap-test:
  stage: test
  script:
    - yarn install --immutable
    - yarn build
    - yarn test
  artifacts:
    paths:
      - packages/snap/target/lcov-report
    when: always
  rules: !reference [.rules, on-mr-and-deploy]

build:
  stage: test
  script:
    - yarn install --immutable
    - yarn build
    - git diff --exit-code
  artifacts:
    paths:
      - packages/snap/dist
  rules: !reference [.rules, on-mr-and-deploy]

deploy-dry-run:
  stage: deploy
  dependencies:
    - build
  script:
    - cd packages/snap/
    - npm publish --dry-run
  rules: !reference [.rules, on-mr-and-deploy]

deploy:
  stage: deploy
  dependencies:
    - build
  script:
    - echo "//registry.npmjs.org/:_authToken=${NPM_AUTH_TOKEN}">.npmrc
    - cd packages/snap/
    - npm publish
  rules: !reference [.rules, on-deploy]
